unit Print;

interface

function stampante_pronta:boolean;
function printinstallato:boolean;
procedure stampainbackground(path:string; var coderr:integer);
procedure rimuovifiledacoda(path:string;var coderr:integer);
procedure cancellatuttidacoda(var coderr:integer);
procedure primofileincoda(var path:string; var coderr:integer);
procedure nextfileincoda(var path:string; var coderr:integer);
procedure continuastampa(var coderr:integer);

implementation

uses dos;

function stampante_pronta:boolean;
var a:integer;
    reg:registers;
begin
  a:=0;
  repeat
    reg.dx:=a;
    reg.ah:=2;
    intr($17,reg);
    inc(a);
  until (((reg.ah and $10)<>0)or(reg.dx=3));
  stampante_pronta:=((reg.ah and $30)=0);
end;



type
  funzionidiprint=
    (installazione,stampa,rimuovifile,cancellatutto,coda,sblocca);
  fileincoda=array[1..64] of char;

var
  codaptr: ^fileincoda;
  i:integer;

procedure int2f(fun:funzionidiprint;var segm,offs:word;var err:integer);
var
  reg:registers;
begin
  reg.ah:=$01;
  reg.al:=byte(fun);
  reg.ds:=segm;
  reg.dx:=offs;
  intr($2f,reg);
  if (reg.flags and 1) <> 0 then
    err:=reg.ax
  else begin
    if fun=installazione then
      if reg.al=$ff then err:=0
      else err:=-1
    else begin
      err:=0;
      if fun=coda then begin
        segm:=reg.ds;
        offs:=reg.si;
      end;
    end;
  end;
end;

function printinstallato:boolean;
var
  s,o:word;
  coderr:integer;
begin
  int2f(installazione,s,o,coderr);
  printinstallato:=coderr=0;
end;

procedure stampainbackground(path:string;var coderr:integer);
var
  s,o:word;
  pacchetto: record
    livello: byte;
    offset:word;
    segmento:word;
  end;
begin
  path:=path+#0;
  pacchetto.livello:=0;
  pacchetto.offset:=ofs(path)+1;
  pacchetto.segmento:=seg(path);
  s:=seg(pacchetto);
  o:=ofs(pacchetto);
  int2f(stampa,s,o,coderr);
end;

procedure rimuovifiledacoda(path:string;var coderr:integer);
var
  s,o:word;
begin
  path:=path+#0;
  s:=seg(path);
  o:=ofs(path)+1;
  int2f(rimuovifile,s,o,coderr);
end;

procedure cancellatuttidacoda(var coderr:integer);
var
  s,o:word;
begin
  int2f(cancellatutto,s,o,coderr);
end;

procedure primofileincoda(var path:string;var coderr:integer);
var
  s,o:word;
  j:integer;
begin
  int2f(coda,s,o,coderr);
  if coderr=0 then begin
    i:=1;
    j:=1;
    codaptr:=ptr(s,0);
    path:='';
    while codaptr^[j]<>#0 do begin
      path:=path+codaptr^[j];
      inc(j);
    end;
    i:=i+64;
  end;
end;

procedure nextfileincoda(var path:string;var coderr:integer);
var
  j:integer;
begin
  j:=i;
  path:='';
  while codaptr^[j]<>#0 do begin
    path:=path+codaptr^[j];
    inc(j);
  end;
  i:=i+64;
end;

procedure continuastampa(var coderr:integer);
var
  s,o:word;
begin
  int2f(sblocca,s,o,coderr);
end;

end.
